/*     
       v0.3 2007 JS new format output
       v0.2 2000 JS (obc corrected)
       
		 2      6
	   \	/ \    / \    /
	    0--1   4--5   8--9
	   /    \ /    \ /    \
	         3      7
*/
#include <stdlib.h>
#include <stdio.h>

int initvars(int n0,int pbc){
   int i,nn,nw;
   nn=((pbc==1)?4*n0:4*n0+2);
   nw=((pbc==1)?6*n0:6*n0+1);
   printf("# def-file, dimer-plaquette\n"
	"# automaticly generated by m_dp v0.2 n0=%d J1=Jd J2=Jp J3=Jf PBC=%d\n"
	"#===edge=== %d 0 0 99\n"
	"#+++model+++\n"
	"# NN=Number_of_sites Nw=Number_of_bonds Nv=Number_of_bonds(2)\n"
	"%d %d 0\n"
	"# s  X  Y  Z e# U# (s=siteindex  (X Y Z)=position  p=index of parameter)\n",
     n0,pbc,n0*3,nn,nw);
   for(i=0;i<n0;i++)
   printf(" %2d %2d %2d 0 e8 u7\n"
          " %2d %2d %2d 0 e8 u7\n"
          " %2d %2d %2d 0 e8 u7\n"
          " %2d %2d %2d 0 e8 u7\n",
          4*i+0,3*i+0,1,
          4*i+1,3*i+1,1,
          4*i+2,3*i+2,0,
          4*i+3,3*i+2,2);
   if(pbc==0) printf(" %2d %2d %2d 0 e8 u7\n",4*n0+0,3*n0+0,1);
   if(pbc==0) printf(" %2d %2d %2d 0 e8 u7\n",4*n0+1,3*n0+1,1);
   printf("# Bond s1 s2 t# J# V# w#\n");
   for(i=0;i<n0;i++){
     printf(" %2d %2d %2d t0  j1 v0 w4\n"
            " %2d %2d %2d t0  j3 v0 w5\n"
            " %2d %2d %2d t0  j2 v0 w6\n"
            " %2d %2d %2d t0  j2 v0 w7\n"
            " %2d %2d %2d t0 %cj2 v0 w7\n"
            " %2d %2d %2d t0 %cj2 v0 w6\n",
            6*i+0,i*4+0,i*4+1,	/* dimer */
            6*i+1,i*4+2,i*4+3,	/* frustration */
            6*i+2,i*4+1,i*4+2,	/* plaquette */
            6*i+3,i*4+1,i*4+3,
            6*i+4,i*4+2,(i*4+4)%nn,((i+1==n0 && pbc==1)?'+':' '),
            6*i+5,i*4+3,(i*4+4)%nn,((i+1==n0 && pbc==1)?'+':' '));
   }
   if(pbc==0) printf(" %2d %2d %2d t0  j1 v0 w4\n",6*n0,4*n0,4*n0+1);
   printf("#---model---\n");
    return 0;}


main(int argc,char *argv[]){
   if(argc!=3){
     fprintf(stderr,
       " generate daten.def for dimer plaquette chain v0.3 JS07\n"
       " use: m_dp ?length? ?PBC?\n"
       "   length: 1..6  chain length divided by 4\n"
       "   PBC:    0/1   open/periodic boundary conditions\n");
     exit(1);
   }
   initvars(atoi(argv[1]),atoi(argv[2]));
}
